import xml.dom.minidom

class erpmScriptInfo:
	title = None
	author = None
	email = None
	homepage = None
	category = None
	summary = None
	description = None
	version = None
	format = None

class erpmScriptRpm:
	prefix = None
	version = None

class erpmScriptScript:
	backup = None
	restore = None
	installPrep = None
	installPost = None
	removePrep = None
	removePost = None


class erpmScript:

	def parseErpmInfo( self, elem):
		self.esInfo.title = elem[0].getElementsByTagName('TITLE')[0].firstChild.nodeValue
		self.esInfo.author = elem[0].getElementsByTagName('AUTHOR')[0].firstChild.nodeValue
		self.esInfo.email = elem[0].getElementsByTagName('EMAIL')[0].firstChild.nodeValue
		self.esInfo.homepage = elem[0].getElementsByTagName('HOMEPAGE')[0].firstChild.nodeValue
		self.esInfo.category = elem[0].getElementsByTagName('CATEGORY')[0].firstChild.nodeValue
		self.esInfo.summary = elem[0].getElementsByTagName('SUMMARY')[0].firstChild.nodeValue
		self.esInfo.description = elem[0].getElementsByTagName('DESCRIPTION')[0].firstChild.nodeValue
		self.esInfo.version = elem[0].getElementsByTagName('VERSION')[0].firstChild.nodeValue
		self.esInfo.format = elem[0].getElementsByTagName('FORMAT')[0].firstChild.nodeValue
		return 

	def parseErpmRpm( self, elem):
		self.esRpm.prefix = elem[0].getElementsByTagName('PREFIX')[0].firstChild.nodeValue
		self.esRpm.version = elem[0].getElementsByTagName('VERSION')[0].firstChild.nodeValue
		return 

	def parseErpmRepo( self, elem):
		for cn in elem[0].getElementsByTagName('REPOSITORY'):
			self.repoList.append(cn.firstChild.nodeValue)
		return 

	def parseErpmScript( self, elem):
		self.esScript.backup = elem[0].getElementsByTagName('BACKUP')[0].firstChild.nodeValue
		self.esScript.restore = elem[0].getElementsByTagName('RESTORE')[0].firstChild.nodeValue
		self.esScript.installPrep = elem[0].getElementsByTagName('INSTALL-PREP')[0].firstChild.nodeValue
		self.esScript.installPost = elem[0].getElementsByTagName('INSTALL-POST')[0].firstChild.nodeValue
		self.esScript.removePrep = elem[0].getElementsByTagName('REMOVE-POST')[0].firstChild.nodeValue
		self.esScript.removePost = elem[0].getElementsByTagName('REMOVE-POST')[0].firstChild.nodeValue
		return 

	def parseErpm( self, erpmDoc):
		self.parseErpmInfo(erpmDoc.getElementsByTagName('INFORMATION'))
		self.parseErpmRpm(erpmDoc.getElementsByTagName('RPM'))
		self.parseErpmRepo(erpmDoc.getElementsByTagName('REPOSITORIES'))
		self.parseErpmScript(erpmDoc.getElementsByTagName('SCRIPT'))

	def __init__( self, filename):
		# erpm datas
		self.esInfo = erpmScriptInfo()
		self.esRpm = erpmScriptRpm()
		self.repoList = []
		self.esScript = erpmScriptScript()
		# open
		erpmFp = open(filename,"r")
		self.erpmDoc = xml.dom.minidom.parse(erpmFp)
		self.parseErpm(self.erpmDoc)

#if __name__ == "__main__":
#	scrt = erpmScript("test.erpm")
#	print scrt.esInfo.title
#	print scrt.esRpm.prefix
#	print scrt.esScript.backup
#	for rp in scrt.repoList:
#		print rp

